/*
 File: lr1_k_phrasesym.cpp
 Date and Time: Fri Jan 30 18:55:15 2015 
*/
#include "lr1_k_phrase.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_lr1_k_phrase;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Clr1_k_phrase::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rlr1_k_phrase_:{
       Rlr1_k_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rlr1_k_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlr1_k_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rphrase_:{
       Rphrase* sym;
     if(re->rule_ == 0){
       sym = new Rphrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rphrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rphrase_:{
       Rphrase* sym;
     if(re->rule_ == 0){
       sym = new Rphrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rphrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rphrase_:{
       Rphrase* sym;
     if(re->rule_ == 0){
       sym = new Rphrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rphrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    default: return;
   }
}
